Cupti: CUpti_ActivityPcie Struct Reference

# CUpti_ActivityPcie Struct Reference
[CUPTI Activity API]

PCI devices information required to construct topology. More...

## Data Fields
union {
} | attr
uint32_t | domain
union {
uint32_t bridgeId
CUdevice devId
} | id
CUpti_ActivityKind | kind
uint16_t | linkRate
uint16_t | linkWidth
uint16_t | pcieGeneration
CUpti_PcieDeviceType | type
uint16_t | upstreamBus
uint16_t | deviceId
uint16_t | pad0
CUdevice | peerDev [CUPTI_MAX_GPUS]
uint16_t | secondaryBus
CUuuid | uuidDev
uint16_t | vendorId

## Detailed Description

This structure gives capabilities of GPU and PCI bridge connected to the PCIE bus which can be used to understand the topology.

## Field Documentation

union { ... } CUpti_ActivityPcie::attr

Attributes for more information about GPU (gpuAttr) or PCI Bridge (bridgeAttr)

uint32_t CUpti_ActivityPcie::bridgeId

A unique identifier for Bridge in the Topology

uint16_t CUpti_ActivityPcie::deviceId

Device ID of the bridge

CUdevice CUpti_ActivityPcie::devId

GPU device ID

uint32_t CUpti_ActivityPcie::domain

Domain for the GPU or Bridge, required to identify which PCIE bus it belongs to in multiple NUMA systems.

union { ... } CUpti_ActivityPcie::id

A unique identifier for GPU or Bridge in Topology

CUpti_ActivityKind CUpti_ActivityPcie::kind

The activity record kind, must be CUPTI_ACTIVITY_KIND_PCIE.

uint16_t CUpti_ActivityPcie::linkRate

Link rate of the GPU or bridge in gigatransfers per second (GT/s)

uint16_t CUpti_ActivityPcie::linkWidth

Link width of the GPU or bridge

uint16_t CUpti_ActivityPcie::pad0

Padding for alignment

uint16_t CUpti_ActivityPcie::pcieGeneration

PCIE Generation of GPU or Bridge.

CUdevice CUpti_ActivityPcie::peerDev[CUPTI_MAX_GPUS]

CUdevice with which this device has P2P capability. This can also be obtained by querying cuDeviceCanAccessPeer or cudaDeviceCanAccessPeer APIs

uint16_t CUpti_ActivityPcie::secondaryBus

The downstream bus number, used to search downstream devices/bridges connected to this bridge.

CUpti_PcieDeviceType CUpti_ActivityPcie::type

Type of device in topology, CUpti_PcieDeviceType. If type is CUPTI_PCIE_DEVICE_TYPE_GPU use devId for id and gpuAttr and if type is CUPTI_PCIE_DEVICE_TYPE_BRIDGE use bridgeId for id and bridgeAttr.

uint16_t CUpti_ActivityPcie::upstreamBus

Upstream bus ID for the GPU or PCI bridge. Required to identify which bus it is connected to in the topology.

CUuuid CUpti_ActivityPcie::uuidDev

UUID for the device. CUpti_ActivityDevice2.

uint16_t CUpti_ActivityPcie::vendorId

Vendor ID of the bridge